Makefile 11 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306
  1. # set the shell to bash always
  2. SHELL := /bin/bash
  3. # set make and shell flags to exit on errors
  4. MAKEFLAGS += --warn-undefined-variables
  5. .SHELLFLAGS := -euo pipefail -c
  6. ARCH ?= amd64 arm64
  7. BUILD_ARGS ?= CGO_ENABLED=0
  8. DOCKER_BUILD_ARGS ?=
  9. DOCKERFILE ?= Dockerfile
  10. # default target is build
  11. .DEFAULT_GOAL := all
  12. .PHONY: all
  13. all: $(addprefix build-,$(ARCH))
  14. # Image registry for build/push image targets
  15. export IMAGE_REGISTRY ?= ghcr.io
  16. export IMAGE_REPO ?= external-secrets/external-secrets
  17. export IMAGE_NAME ?= $(IMAGE_REGISTRY)/$(IMAGE_REPO)
  18. BUNDLE_DIR ?= deploy/crds
  19. CRD_DIR ?= config/crds
  20. HELM_DIR ?= deploy/charts/external-secrets
  21. TF_DIR ?= terraform
  22. OUTPUT_DIR ?= bin
  23. # Get the currently used golang install path (in GOPATH/bin, unless GOBIN is set)
  24. ifeq (,$(shell go env GOBIN))
  25. GOBIN=$(shell go env GOPATH)/bin
  26. else
  27. GOBIN=$(shell go env GOBIN)
  28. endif
  29. # check if there are any existing `git tag` values
  30. ifeq ($(shell git tag),)
  31. # no tags found - default to initial tag `v0.0.0`
  32. export VERSION := $(shell echo "v0.0.0-$$(git rev-list HEAD --count)-g$$(git describe --dirty --always)" | sed 's/-/./2' | sed 's/-/./2')
  33. else
  34. # use tags
  35. export VERSION := $(shell git describe --dirty --always --tags --exclude 'helm*' | sed 's/-/./2' | sed 's/-/./2')
  36. endif
  37. TAG_SUFFIX ?=
  38. export IMAGE_TAG ?= $(VERSION)$(TAG_SUFFIX)
  39. # ====================================================================================
  40. # Colors
  41. BLUE := $(shell printf "\033[34m")
  42. YELLOW := $(shell printf "\033[33m")
  43. RED := $(shell printf "\033[31m")
  44. GREEN := $(shell printf "\033[32m")
  45. CNone := $(shell printf "\033[0m")
  46. # ====================================================================================
  47. # Logger
  48. TIME_LONG = `date +%Y-%m-%d' '%H:%M:%S`
  49. TIME_SHORT = `date +%H:%M:%S`
  50. TIME = $(TIME_SHORT)
  51. INFO = echo ${TIME} ${BLUE}[ .. ]${CNone}
  52. WARN = echo ${TIME} ${YELLOW}[WARN]${CNone}
  53. ERR = echo ${TIME} ${RED}[FAIL]${CNone}
  54. OK = echo ${TIME} ${GREEN}[ OK ]${CNone}
  55. FAIL = (echo ${TIME} ${RED}[FAIL]${CNone} && false)
  56. # ====================================================================================
  57. # Conformance
  58. reviewable: generate docs manifests helm.generate helm.docs lint ## Ensure a PR is ready for review.
  59. @go mod tidy
  60. @cd e2e/ && go mod tidy
  61. check-diff: reviewable ## Ensure branch is clean.
  62. @$(INFO) checking that branch is clean
  63. @test -z "$$(git status --porcelain)" || (echo "$$(git status --porcelain)" && $(FAIL))
  64. @$(OK) branch is clean
  65. update-deps:
  66. go get -u
  67. cd e2e && go get -u
  68. @go mod tidy
  69. @cd e2e/ && go mod tidy
  70. # ====================================================================================
  71. # Golang
  72. .PHONY: test
  73. test: generate ## Run tests
  74. @$(INFO) go test unit-tests
  75. go test -race -v $(shell go list ./... | grep -v e2e) -coverprofile cover.out
  76. @$(OK) go test unit-tests
  77. .PHONY: test.e2e
  78. test.e2e: generate ## Run e2e tests
  79. @$(INFO) go test e2e-tests
  80. $(MAKE) -C ./e2e test
  81. @$(OK) go test e2e-tests
  82. .PHONY: test.e2e.managed
  83. test.e2e.managed: generate ## Run e2e tests managed
  84. @$(INFO) go test e2e-tests-managed
  85. $(MAKE) -C ./e2e test.managed
  86. @$(OK) go test e2e-tests-managed
  87. .PHONY: build
  88. build: $(addprefix build-,$(ARCH)) $(addprefix build-providerless-,$(ARCH)) build-provider ## Build binary
  89. .PHONY: build-provider
  90. build-provider: $(addprefix build-provider-,$(ARCH)) ## Build binary
  91. .PHONY: build-%
  92. build-%: generate ## Build binary for the specified arch
  93. @$(INFO) go build $*
  94. $(BUILD_ARGS) GOOS=linux GOARCH=$* \
  95. go build -o '$(OUTPUT_DIR)/external-secrets-linux-$*' main.go
  96. @$(OK) go build $*
  97. .PHONY: build-providerless-%
  98. build-providerless-%: generate ## Build binary for the specified arch
  99. @$(INFO) go build $*
  100. $(BUILD_ARGS) GOOS=linux GOARCH=$* \
  101. go build -tags providerless -o '$(OUTPUT_DIR)/external-secrets-linux-$*-providerless' main.go
  102. @$(OK) go build $*
  103. .PHONY: build-provider-%
  104. build-provider-%: generate ## Build binary for the specified arch
  105. @$(INFO) go build $*
  106. $(BUILD_ARGS) GOOS=linux GOARCH=$* \
  107. ./hack/build-provider.sh
  108. @$(OK) go build $*
  109. lint.check: ## Check install of golanci-lint
  110. @if ! golangci-lint --version > /dev/null 2>&1; then \
  111. echo -e "\033[0;33mgolangci-lint is not installed: run \`\033[0;32mmake lint.install\033[0m\033[0;33m\` or install it from https://golangci-lint.run\033[0m"; \
  112. exit 1; \
  113. fi
  114. lint.install: ## Install golangci-lint to the go bin dir
  115. @if ! golangci-lint --version > /dev/null 2>&1; then \
  116. echo "Installing golangci-lint"; \
  117. curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(GOBIN) v1.49.0; \
  118. fi
  119. lint: lint.check ## Run golangci-lint
  120. @if ! golangci-lint run; then \
  121. echo -e "\033[0;33mgolangci-lint failed: some checks can be fixed with \`\033[0;32mmake fmt\033[0m\033[0;33m\`\033[0m"; \
  122. exit 1; \
  123. fi
  124. @$(OK) Finished linting
  125. fmt: lint.check ## Ensure consistent code style
  126. @go mod tidy
  127. @cd e2e/ && go mod tidy
  128. @go fmt ./...
  129. @golangci-lint run --fix > /dev/null 2>&1 || true
  130. @$(OK) Ensured consistent code style
  131. generate: ## Generate code and crds
  132. protoc --go_out=. --go_opt=paths=source_relative \
  133. --go-grpc_out=. --go-grpc_opt=paths=source_relative \
  134. ./pkg/plugin/grpc/provider.proto
  135. ./cmd/provider/generate.sh
  136. go generate ./cmd/provider/provider.go.tmpl
  137. @./hack/crd.generate.sh $(BUNDLE_DIR) $(CRD_DIR)
  138. @$(OK) Finished generating deepcopy and crds
  139. # ====================================================================================
  140. # Local Utility
  141. # This is for running out-of-cluster locally, and is for convenience.
  142. # For more control, try running the binary directly with different arguments.
  143. run: generate ## Run app locally (without a k8s cluster)
  144. go run ./main.go
  145. manifests: helm.generate ## Generate manifests from helm chart
  146. mkdir -p $(OUTPUT_DIR)/deploy/manifests
  147. helm template external-secrets $(HELM_DIR) -f deploy/manifests/helm-values.yaml > $(OUTPUT_DIR)/deploy/manifests/external-secrets.yaml
  148. crds.install: generate ## Install CRDs into a cluster. This is for convenience
  149. kubectl apply -f $(BUNDLE_DIR)
  150. crds.uninstall: ## Uninstall CRDs from a cluster. This is for convenience
  151. kubectl delete -f $(BUNDLE_DIR)
  152. # ====================================================================================
  153. # Helm Chart
  154. helm.docs: ## Generate helm docs
  155. @cd $(HELM_DIR); \
  156. docker run --rm -v $(shell pwd)/$(HELM_DIR):/helm-docs -u $(shell id -u) jnorwood/helm-docs:v1.5.0
  157. HELM_VERSION ?= $(shell helm show chart $(HELM_DIR) | grep 'version:' | sed 's/version: //g')
  158. helm.build: helm.generate ## Build helm chart
  159. @$(INFO) helm package
  160. @helm package $(HELM_DIR) --dependency-update --destination $(OUTPUT_DIR)/chart
  161. @mv $(OUTPUT_DIR)/chart/external-secrets-$(HELM_VERSION).tgz $(OUTPUT_DIR)/chart/external-secrets.tgz
  162. @$(OK) helm package
  163. helm.generate:
  164. ./hack/helm.generate.sh $(BUNDLE_DIR) $(HELM_DIR)
  165. @$(OK) Finished generating helm chart files
  166. helm.test: helm.generate
  167. @helm unittest --file tests/*.yaml --file 'tests/**/*.yaml' deploy/charts/external-secrets/
  168. helm.test.update: helm.generate
  169. @helm unittest -u --file tests/*.yaml --file 'tests/**/*.yaml' deploy/charts/external-secrets/
  170. helm.update.appversion:
  171. @chartversion=$$(yq .version ./deploy/charts/external-secrets/Chart.yaml) ; \
  172. chartappversion=$$(yq .appVersion ./deploy/charts/external-secrets/Chart.yaml) ; \
  173. chartname=$$(yq .name ./deploy/charts/external-secrets/Chart.yaml) ; \
  174. $(INFO) Update chartname and chartversion string in test snapshots.; \
  175. sed -s -i "s/^\([[:space:]]\+helm\.sh\/chart:\).*/\1 $${chartname}-$${chartversion}/" ./deploy/charts/external-secrets/tests/__snapshot__/*.yaml.snap ; \
  176. sed -s -i "s/^\([[:space:]]\+app\.kubernetes\.io\/version:\).*/\1 $${chartappversion}/" ./deploy/charts/external-secrets/tests/__snapshot__/*.yaml.snap ; \
  177. sed -s -i "s/^\([[:space:]]\+image: ghcr\.io\/external-secrets\/external-secrets:\).*/\1$${chartappversion}/" ./deploy/charts/external-secrets/tests/__snapshot__/*.yaml.snap ; \
  178. $(OK) "Version strings updated"
  179. # ====================================================================================
  180. # Documentation
  181. .PHONY: docs
  182. docs: generate ## Generate docs
  183. $(MAKE) -C ./hack/api-docs build
  184. .PHONY: docs.publish
  185. docs.publish: generate ## Generate and deploys docs
  186. $(MAKE) -C ./hack/api-docs build.publish
  187. .PHONY: docs.serve
  188. docs.serve: ## Serve docs
  189. $(MAKE) -C ./hack/api-docs serve
  190. # ====================================================================================
  191. # Build Artifacts
  192. build.all: docker.build helm.build ## Build all artifacts (docker image, helm chart)
  193. docker.image:
  194. @echo $(IMAGE_NAME):$(IMAGE_TAG)
  195. docker.tag:
  196. @echo $(IMAGE_TAG)
  197. docker.build: build ## Build the docker image
  198. @$(INFO) docker build
  199. @docker build -f $(DOCKERFILE) . $(DOCKER_BUILD_ARGS) -t $(IMAGE_NAME):$(IMAGE_TAG)
  200. @$(OK) docker build
  201. docker.push: ## Push the docker image to the registry
  202. @$(INFO) docker push
  203. @docker push $(IMAGE_NAME):$(IMAGE_TAG)
  204. @$(OK) docker push
  205. # RELEASE_TAG is tag to promote. Default is promoting to main branch, but can be overriden
  206. # to promote a tag to a specific version.
  207. RELEASE_TAG ?= $(IMAGE_TAG)
  208. SOURCE_TAG ?= $(VERSION)$(TAG_SUFFIX)
  209. docker.promote: ## Promote the docker image to the registry
  210. @$(INFO) promoting $(SOURCE_TAG) to $(RELEASE_TAG)
  211. docker manifest inspect --verbose $(IMAGE_NAME):$(SOURCE_TAG) > .tagmanifest
  212. for digest in $$(jq -r 'if type=="array" then .[].Descriptor.digest else .Descriptor.digest end' < .tagmanifest); do \
  213. docker pull $(IMAGE_NAME)@$$digest; \
  214. done
  215. docker manifest create $(IMAGE_NAME):$(RELEASE_TAG) \
  216. $$(jq -j '"--amend $(IMAGE_NAME)@" + if type=="array" then .[].Descriptor.digest else .Descriptor.digest end + " "' < .tagmanifest)
  217. docker manifest push $(IMAGE_NAME):$(RELEASE_TAG)
  218. @$(OK) docker push $(RELEASE_TAG) \
  219. # ====================================================================================
  220. # Terraform
  221. tf.plan.%: ## Runs terrform plan for a provider
  222. @cd $(TF_DIR)/$*; \
  223. terraform init; \
  224. terraform plan
  225. tf.apply.%: ## Runs terrform apply for a provider
  226. @cd $(TF_DIR)/$*; \
  227. terraform init; \
  228. terraform apply -auto-approve
  229. tf.destroy.%: ## Runs terrform destroy for a provider
  230. @cd $(TF_DIR)/$*; \
  231. terraform init; \
  232. terraform destroy -auto-approve
  233. tf.show.%: ## Runs terrform show for a provider and outputs to a file
  234. @cd $(TF_DIR)/$*; \
  235. terraform init; \
  236. terraform plan -out tfplan.binary; \
  237. terraform show -json tfplan.binary > plan.json
  238. # ====================================================================================
  239. # Help
  240. # only comments after make target name are shown as help text
  241. help: ## Displays this help message
  242. @echo -e "$$(grep -hE '^\S+:.*##' $(MAKEFILE_LIST) | sed -e 's/:.*##\s*/:/' -e 's/^\(.\+\):\(.*\)/\\x1b[36m\1\\x1b[m:\2/' | column -c2 -t -s : | sort)"